package jdk.internal.org.objectweb.asm.tree.analysis;

import java.util.ArrayList;
import jdk.internal.org.objectweb.asm.tree.JumpInsnNode;
import java.util.List;
import jdk.internal.org.objectweb.asm.tree.LabelNode;

class Subroutine
{
    LabelNode start;
    boolean[] access;
    List<JumpInsnNode> callers;
    
    private Subroutine() {
    }
    
    Subroutine(LabelNode start, int n, JumpInsnNode jumpInsnNode) {
        this.start = start;
        this.access = new boolean[n];
        (this.callers = new ArrayList()).add(jumpInsnNode);
    }
    
    public Subroutine copy() {
        Subroutine subroutine = new Subroutine();
        subroutine.start = this.start;
        subroutine.access = new boolean[this.access.length];
        System.arraycopy(this.access, 0, subroutine.access, 0, this.access.length);
        subroutine.callers = new ArrayList(this.callers);
        return subroutine;
    }
    
    public boolean merge(Subroutine subroutine) throws AnalyzerException {
        boolean n = false;
        for (int i = 0; i < this.access.length; ++i) {
            if (subroutine.access[i] && !this.access[i]) {
                this.access[i] = true;
                n = true;
            }
        }
        if (subroutine.start == this.start) {
            for (int j = 0; j < subroutine.callers.size(); ++j) {
                JumpInsnNode jumpInsnNode = (JumpInsnNode)subroutine.callers.get(j);
                if (!this.callers.contains(jumpInsnNode)) {
                    this.callers.add(jumpInsnNode);
                    n = true;
                }
            }
        }
        return n;
    }
}
